diff --git a/sysdeps/unix/sysv/linux/aarch64/gettimeofday.c b/sysdeps/unix/sysv/linux/aarch64/gettimeofday.c
index 143c5c1507..f28260c8e9 100644
--- a/sysdeps/unix/sysv/linux/aarch64/gettimeofday.c
+++ b/sysdeps/unix/sysv/linux/aarch64/gettimeofday.c
@@ -16,39 +16,5 @@
    License along with the GNU C Library; if not, see
    <https://www.gnu.org/licenses/>.  */
 
-/* Get the current time of day and timezone information,
-   putting it into *tv and *tz.  If tz is null, *tz is not filled.
-   Returns 0 on success, -1 on errors.  */
-
-#include <time.h>
-#include <sysdep.h>
-#include <sysdep-vdso.h>
-
-/* Used as a fallback in the ifunc resolver if VDSO is not available
-   and for libc.so internal __gettimeofday calls.  */
-static int
-__gettimeofday_vsyscall (struct timeval *restrict tv, void *restrict tz)
-{
-  if (__glibc_unlikely (tz != 0))
-    memset (tz, 0, sizeof *tz);
-
-  return INLINE_VSYSCALL (gettimeofday, 2, tv, tz);
-}
-
-#ifdef SHARED
-# include <dl-vdso.h>
-# include <sysdep-vdso.h>
-
-# define INIT_ARCH()
-libc_ifunc (__gettimeofday,
-	    (get_vdso_symbol (HAVE_GETTIMEOFDAY_VSYSCALL)
-	    ?: __gettimeofday_vsyscall))
-
-#else
-int
-__gettimeofday (struct timeval *restrict tv, void *restrict tz)
-{
-  return __gettimeofday_vsyscall (tv, tz);
-}
-#endif
-weak_alias (__gettimeofday, gettimeofday)
+#define USE_IFUNC_GETTIMEOFDAY
+#include <sysdeps/unix/sysv/linux/gettimeofday.c>
diff --git a/sysdeps/unix/sysv/linux/gettimeofday.c b/sysdeps/unix/sysv/linux/gettimeofday.c
new file mode 100644
index 0000000000..600da6b468
--- /dev/null
+++ b/sysdeps/unix/sysv/linux/gettimeofday.c
@@ -0,0 +1,57 @@
+/* gettimeofday - set time.  Linux version.
+   Copyright (C) 2019 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public License as
+   published by the Free Software Foundation; either version 2.1 of the
+   License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+/* Some architecture might optimize the gettimeofday by setting the plt direct
+   to vDSO symbol by using a IFUNC.  */
+#ifdef USE_IFUNC_GETTIMEOFDAY
+# include <time.h>
+# include <sysdep.h>
+# include <sysdep-vdso.h>
+
+# ifdef SHARED
+#  include <dl-vdso.h>
+
+static int
+__gettimeofday_syscall (struct timeval *restrict tv, void *restrict tz)
+{
+  if (__glibc_unlikely (tz != 0))
+    memset (tz, 0, sizeof *tz);
+  return INLINE_SYSCALL_CALL (gettimeofday, tv, tz);
+}
+
+# undef INIT_ARCH
+# define INIT_ARCH() \
+  void *vdso_gettimeofday = get_vdso_symbol (HAVE_GETTIMEOFDAY_VSYSCALL)
+libc_ifunc (__gettimeofday,
+	    vdso_gettimeofday ? VDSO_IFUNC_RET (vdso_gettimeofday)
+			      : (void *) __gettimeofday_syscall)
+
+# else
+int
+__gettimeofday (struct timeval *restrict tv, void *restrict tz)
+{
+  if (__glibc_unlikely (tz != 0))
+    memset (tz, 0, sizeof *tz);
+
+  return INLINE_VSYSCALL (gettimeofday, 2, tv, tz);
+}
+# endif
+weak_alias (__gettimeofday, gettimeofday)
+#else /* USE_IFUNC_GETTIMEOFDAY  */
+# include <time/gettimeofday.c>
+#endif
diff --git a/sysdeps/unix/sysv/linux/powerpc/gettimeofday.c b/sysdeps/unix/sysv/linux/powerpc/gettimeofday.c
index c40793fe64..b2137f0d2d 100644
--- a/sysdeps/unix/sysv/linux/powerpc/gettimeofday.c
+++ b/sysdeps/unix/sysv/linux/powerpc/gettimeofday.c
@@ -15,36 +15,5 @@
    License along with the GNU C Library; if not, see
    <https://www.gnu.org/licenses/>.  */
 
-#include <time.h>
-#include <sysdep.h>
-#include <sysdep-vdso.h>
-
-static int
-__gettimeofday_syscall (struct timeval *restrict tv, void *restrict tz)
-{
-  if (__glibc_unlikely (tz != 0))
-    memset (tz, 0, sizeof *tz);
-
-  return INLINE_VSYSCALL (gettimeofday, 2, tv, tz);
-}
-
-#ifdef SHARED
-# include <dl-vdso.h>
-# include <libc-vdso.h>
-
-# define INIT_ARCH() \
-  void *vdso_gettimeofday = get_vdso_symbol (HAVE_GETTIMEOFDAY_VSYSCALL)
-
-/* If the vDSO is not available we fall back syscall.  */
-libc_ifunc (__gettimeofday,
-	    vdso_gettimeofday
-	    ? VDSO_IFUNC_RET (vdso_gettimeofday)
-	    : (void *) __gettimeofday_syscall);
-#else
-int
-__gettimeofday (struct timeval *restrict tv, void *restrict tz)
-{
-  return __gettimeofday_syscall (tv, tz);
-}
-#endif
-weak_alias (__gettimeofday, gettimeofday)
+#define USE_IFUNC_GETTIMEOFDAY
+#include <sysdeps/unix/sysv/linux/gettimeofday.c>
diff --git a/sysdeps/unix/sysv/linux/x86/gettimeofday.c b/sysdeps/unix/sysv/linux/x86/gettimeofday.c
index 8015c40210..39e662c514 100644
--- a/sysdeps/unix/sysv/linux/x86/gettimeofday.c
+++ b/sysdeps/unix/sysv/linux/x86/gettimeofday.c
@@ -16,34 +16,5 @@
    License along with the GNU C Library; if not, see
    <https://www.gnu.org/licenses/>.  */
 
-#include <time.h>
-#include <sysdep.h>
-#include <sysdep-vdso.h>
-
-static int
-__gettimeofday_syscall (struct timeval *restrict tv, void *restrict tz)
-{
-  if (__glibc_unlikely (tz != 0))
-    memset (tz, 0, sizeof *tz);
-
-  return INLINE_VSYSCALL (gettimeofday, 2, tv, tz);
-}
-
-#ifdef SHARED
-# include <dl-vdso.h>
-# include <libc-vdso.h>
-
-# define INIT_ARCH()
-/* If the vDSO is not available we fall back to syscall.  */
-libc_ifunc (__gettimeofday,
-	    (get_vdso_symbol (HAVE_GETTIMEOFDAY_VSYSCALL)
-	    ?: __gettimeofday_syscall));
-
-#else
-int
-__gettimeofday (struct timeval *restrict tv, void *restrict tz)
-{
-  return __gettimeofday_syscall (tv, tz);
-}
-#endif
-weak_alias (__gettimeofday, gettimeofday)
+#define USE_IFUNC_GETTIMEOFDAY
+#include <sysdeps/unix/sysv/linux/gettimeofday.c>